package example;

import java.io.*;
import java.net.*;

public class EchoClient {
	Socket echoSocket = null;
	PrintWriter out = null;
	BufferedReader in = null;

	public EchoClient() {
		// TODO Auto-generated constructor stub
		try {
			// Create a new socket for the client
			echoSocket = new Socket("localhost", 8080);
			// OutputStream to send messages to the Server
			out = new PrintWriter(echoSocket.getOutputStream(), true);

			// InputStream to get messages from the Server
			in = new BufferedReader(new InputStreamReader(
					echoSocket.getInputStream()));
		} catch (UnknownHostException e) {
			System.err.println("Don't know about host: localhost.");
			System.exit(1);
		} catch (IOException e) {
			System.err.println("Couldn't get I/O for "
					+ "the connection to: localhost.");
			System.exit(1);
		}
	}

	public void run() {

		// Create a buffer reader for the user input
		BufferedReader stdIn = new BufferedReader(new InputStreamReader(
				System.in));

		String userInput = "";

		try {
			System.out.println(in.readLine());
			while (!userInput.equals("bye")) {
				userInput = stdIn.readLine();
				out.println(userInput);

				System.out.println("echo: " + in.readLine());

			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// Housekeeping
		try {
			out.close();
			in.close();
			stdIn.close();
			echoSocket.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws IOException {
		EchoClient echoClient = new EchoClient();
		echoClient.run();
	}
}
