package example;

/* EchoServer.java
 */

import java.io.*;
import java.net.*;

public class EchoServer {

	private ServerSocket server;

	public EchoServer(int portnum) {
		try {
			// Create new socket that listen any new requests
			server = new ServerSocket(portnum);
		} catch (Exception err) {
			System.out.println(err);
		}
	}

	public void run() {
		try {
			System.out.println("EchoServer is started!");
			// Accept is a blocking operation
			while (true) {
				// Get client socket
				Socket client = server.accept();
				BufferedReader r = new BufferedReader(new InputStreamReader(
						client.getInputStream()));
				PrintWriter w = new PrintWriter(client.getOutputStream(), true);
				w.println("Welcome to the Java EchoServer.  Type 'bye' to close.");
				String line;
				// Actual Communication with the client
				do {
					line = r.readLine();
					if (line != null)
						w.println(line);
				} while (!line.trim().equals("bye"));
				client.close();
			}
		} catch (Exception err) {
			System.err.println(err);
		}
	}

	public static void main(String[] args) {
		EchoServer s = new EchoServer(8080);
		s.run();
	}

}